/*

  BST.java
  
  Binary Search Tree Exercises
  COSC 102, Colgate University
  
*/


import java.util.*;

public class BST
{
    // component node class
    private static class Node
    {
        int key;
        Node left;
        Node right;
        
        Node() { super(); }
        
        Node(int key) { super(); this.key = key; }
    }
    
    // keeps track of root and size
    private Node root;
    private int size;
    
    // default constructor    
    public BST() { super(); }
    
    
    // method to access number of keys in the tree
    public int size()
    {
        return size;
    }
    
    // standard BST insert -- non-balancing
    public boolean insert (int key)
    {
        if (root == null) {
            root = new Node(key);
            size = 1;
            return true;
        }
            
        return insert(root, key);    
    }
    
    // recursive helper for insert
    private boolean insert (Node n, int key)    
    {
        if (n.key == key)
            return false;
        
        if (key > n.key) {
            if (n.right == null) {
                n.right = new Node(key);
                size++;
                return true;
            }
            else
                return insert(n.right, key);
        }
        else {  // key < n.key
            if (n.left == null) {
                n.left = new Node(key);
                size++;
                return true;
            }
            else
                return insert(n.left, key);
        }
    }
    
    // tests if an element is in the tree
    public boolean contains (int key)
    {
        Node n = root;
        while (n != null) {
            if (n.key == key) return true;
            if (key < n.key)
                n = n.left;
            else
                n = n.right;
        }
        
        return false;
    }
    
    // prints a preorder traversal, with X for null pointers
    public void preorder ()
    {
        preorder(root);
        System.out.println();
    }
    
    // recursive helper for preorder traversal
    private void preorder (Node root)
    {
        if (root == null) {
            System.out.print("X ");
            return;
        }
            
        System.out.print(root.key);
        System.out.print(' ');
        
        preorder(root.left);
        preorder(root.right);
    }
    
    /*******************
    methods to fill
    *********************/
    public int height ()
    {
        return -1;
    }
    
    public String printByLevel ()
    {
        return null;
    }
     
    public int LCA (int x, int y)
    {
        // fill in code here, only throwing the exception if low and high aren't in the tree
        throw new NoSuchElementException();
    }
    
    
    public Iterable<Integer> findBetween (int x, int y)
    {
        // fill in code here, replacing return value
        return null;
    } 


    /************
    
    for testing
    
    ************/
    
    public static void main (String[] args)
    {
        /* you can use this to test your code
        
        for example:*/
           
           BST tree = new BST();
           tree.insert(10);
           tree.insert(5);
           tree.insert(15);
           tree.insert(12);
           tree.insert(18);
           tree.preorder();
           
           BST tree2 = new BST();
           tree2.insert(10);
           tree2.insert(5);
           tree2.insert(15);
           tree2.insert(8);
           tree2.insert(16);
           tree2.preorder();
       
    }
    
}